> For the complete documentation index, see [llms.txt](https://docs.digit.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.digit.org/platform/platform/core-services/mdms-v2-master-data-management-service/mdms-master-data-management-service/setting-up-master-data/adding-new-master.md).

# Adding New Master

## Overview

For creating a new master in MDMS, create the JSON file with the master data and configure the newly created master in the master config file.

## Pre-requisites

Before proceeding with the configuration, make sure the following pre-requisites are met -

* User with permission to edit the git repository where MDMS data is configured.

## Deployment Details

After adding the new master, the MDMS service needs to be restarted to read the newly added data.

## Configuration Details

### **Creating Master JSON**

The new JSON file needs to contain 3 keys as shown in the below code snippet.\
The new master can be created either State-wise or ULB-wise. Tenant ID and config in the master config file determine this.

```
{
  "tenantId": "< TENANT ID >",
  "moduleName": "< MODULE NAME >",
  "< MASTER NAME >": []
}
```

### **Configuring Master Config File**

The master config file is structured as below. Each key in the master config is a module and each key in the module is a master.

```
{
  "<module1>":{
    "<master1>":{},
    "<master2>":{},
    ...
  },
  "<module2>":{
    <master3>:{},
    <master4>:{},
    ...
  },
  ...
}
```

Each master contains the following data and the keys are self-explanatory

```
"master":{
    "masterName": "<>",
    "isStateLevel": true,
    "uniqueKeys": []
}
```

## Reference Docs

### Doc Links

| Description                                                                                                                                               |
| --------------------------------------------------------------------------------------------------------------------------------------------------------- |
| [Sample master file](https://github.com/egovernments/playground-mdms-data/blob/master/data/pg/PropertyTax/ConstructionType.json)                          |
| [Sample master configuration](https://github.com/egovernments/playground-mdms-data/blob/081a232c26be11a9d803d4490e01d49a7e35985c/master-config.json#L561) |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.digit.org/platform/platform/core-services/mdms-v2-master-data-management-service/mdms-master-data-management-service/setting-up-master-data/adding-new-master.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
